//PROFILE-NO
{$O-}
{$D-}
{$Q-}
{$R-}
{$B-}
{$I-}
{$X+}
{$WARNINGS OFF }

unit NProfint;

interface

USES
  Borland.Vcl.Dialogs, Borland.Vcl.Windows,
  System.Runtime.InteropServices,
  NProfCalibra;

// Profiler-Measurement-Functions
PROCEDURE NProfStop;                                 external 'NPROFMEA.DLL';
PROCEDURE NProfEnter ( prozNr : Integer );           stdcall;  external 'NPROFMEA.DLL';
PROCEDURE NProfExit  ( prozNr : Integer );           stdcall;  external 'NPROFMEA.DLL';
PROCEDURE NProfActivate;                             external 'NPROFMEA.DLL';
PROCEDURE NProfDeActivate;                           external 'NPROFMEA.DLL';
PROCEDURE NProfSetComment ( comm : String );
PROCEDURE NProfSetFinalComment;                      external 'NPROFMEA.DLL';
PROCEDURE NProfAppendResults ( progEnd : Boolean );  stdcall; external 'NPROFMEA.DLL';

// Functions to interrupt and continue measurement for calls which could set the
//  Process idle. Use these calls to implement own Non-measured Calls. If METHODS
//  can set a process idle, the only possibility is, to put these calls into your
//  sources (included by an IFDEF-statement).
//  USE 2 or more spaces between IFDEF and PROFILE, otherwise it will be deleted
//  by the ProDelphi. Example:
//  {$IFDEF     PROFILE } StopCounting;     {$ENDIF }
//    ObjectReference.MethodThatMightSetProcessIdle;
//  {$IFDEF     PROFILE } ContinueCounting; {$ENDIF }

// Normal procedures that set the process idle can be handled like the Sleep-
//  function in this unit.
PROCEDURE NStopCounting;                          external 'NPROFMEA.DLL';
PROCEDURE NContinueCounting;                      external 'NPROFMEA.DLL';

// Function for Starting the Online-Operation windoe
PROCEDURE NProfOnlineOperation;                   external 'NProfOnF.DLL';
PROCEDURE NProfCloseOnlineOperation;              external 'NProfOnF.DLL';

// Delphi-TApplication-Functions that set process idle (handled in DLL)
PROCEDURE ProcessMessages;
PROCEDURE HandleMessage;

// Delphi-Functions that set process idle
PROCEDURE ShowMessage ( CONST Msg  : String );

          // If you need to compile the VCL, the next function must be deleted,
          // Sorry ! The USES statement for Dialogs has to be moved to the
          // Implementation part !!!

FUNCTION MessageBox ( hWnd : HWND; lpText, lpCaption: String; uType : UINT ) : Integer;

FUNCTION MessageBoxEx ( hWnd : HWND; lpText, lpCaption: String; uType : UINT; lang : Word ) : Integer;

function  MessageDlg( const Msg : string;         AType   : TMsgDlgType;
                      AButtons  : TMsgDlgButtons; HelpCtx : Longint ) : Word;

function  MessageDlgPos( const Msg : string;         DlgType : TMsgDlgType;
                         Buttons   : TMsgDlgButtons; HelpCtx: Longint;
                         X, Y      : Integer) : Word;
FUNCTION  AMessageBox( Text, Caption  : String;
                       Flags : Word ) : Integer;

function  WaitCommEvent ( hFile              : THandle;
                          out lpEvtMask      : DWORD;
                          const lpOverlapped : TOverlapped) : BOOL; overload;

function  WaitCommEvent ( hFile              : THandle;
                          out lpEvtMask      : DWORD;
                          lpOverlapped       : IntPtr) : BOOL; overload;

function  WaitNamedPipe (lpNamedPipeName : string; nTimeOut : DWORD) : BOOL;

// Windows-Functions that set process idle
FUNCTION  DispatchMessage(CONST lpMsg  : TMsg) : Longint;

function  DialogBox ( hInstance    : HINST;
                      lpTemplate   : string;
                      hWndParent   : HWND;
                      lpDialogFunc : TFNDlgProc ) : Integer;

FUNCTION  DialogBoxIndirect( hInstance  : HINST; const lpDialogTemplate : TDlgTemplate;
                             hWndParent : HWND;        lpDialogFunc     : TFNDlgProc): Integer;

FUNCTION  SignalObjectAndWait ( h1, h2 : THandle;
                                ms     : DWord;
                                al     : BOOL) : BOOL;

FUNCTION  WaitForSingleObject ( h1     : THandle;
                                MS     : DWORD ) : DWORD;
FUNCTION  WaitForSingleObjectEx ( h1   : THandle;
                                  MS   : DWORD;
                                  al   : BOOL ) : DWORD;
function WaitForMultipleObjects(ct             : DWORD;
                                [in] lpHandles : array of THandle;
                                Wait           : BOOL;
                                ms             : DWORD): DWORD;
function WaitForMultipleObjectsEx(ct             : DWORD;
                                  [in] lpHandles : array of THandle;
                                  Wait           : BOOL;
                                  ms             : DWORD;
                                  al             : BOOL ) : DWORD;
function MsgWaitForMultipleObjects(ct            : DWORD;
                                   [in] pHandles : array of THandle;
                                   Wait          : BOOL;
                                   ms, wm        : DWORD) : DWORD;
function MsgWaitForMultipleObjectsEx(ct            : DWORD;
                                     [in] pHandles : array of THandle;
                                     ms, wm, fl    : DWORD) : DWORD;

PROCEDURE Sleep   (zeit : DWORD );
FUNCTION  SleepEx (zeit : DWORD; alertable : BOOL ) : DWORD;

FUNCTION  WaitForInputIdle ( hp : THandle; ms : DWORD ) : DWORD;
FUNCTION  WaitMessage : BOOL;

// Internal Functions, do not use
PROCEDURE NIntProfSetComment ( Index : Integer; comm : Char ); stdcall; external 'NPROFMEA.DLL';


IMPLEMENTATION
USES
  Borland.Vcl.Forms,
  Borland.Vcl.SysUtils;

// Profiler-Internal-Functions, DO NOT USE
FUNCTION  NProfGlobalInit1 : Boolean;                external 'NPROFMEA.DLL';
PROCEDURE NProfGlobalInit2 ( j : Integer ); stdcall; external 'NPROFMEA.DLL';
PROCEDURE NProfUnInitTimer;                          external 'NPROFMEA.DLL';
FUNCTION  NProfIsInitialised : Integer;              external 'NPROFMEA.DLL';
FUNCTION  NProfMustBeUnInitialised : Integer;        external 'NPROFMEA.DLL';

PROCEDURE ShowMessage ( CONST Msg  : String );
BEGIN
  NStopCounting;
  Borland.Vcl.Dialogs.ShowMessage(Msg);
  NContinueCounting;
END;

PROCEDURE ShowMessageFmt(const Msg : string; Params : array of const );
BEGIN
  NStopCounting;
  Borland.Vcl.Dialogs.ShowMessageFmt(Msg, Params);
  NContinueCounting;
END;

{$IFDEF CLR}
FUNCTION AMessageBox( Text, Caption     : String;
                      Flags : Word ) : Integer;
BEGIN
  NStopCounting;
  Result := Application.MessageBox(Text, Caption,Flags);
  NContinueCounting;
END;

FUNCTION MessageDlg( const Msg : string;         AType   : TMsgDlgType;
                     AButtons  : TMsgDlgButtons; HelpCtx : Longint ) : Word;
BEGIN
  NStopCounting;
  Result := Borland.Vcl.Dialogs.MessageDlg(Msg, AType, AButtons, HelpCtx);
  NContinueCounting;
END;

FUNCTION MessageDlgPos( const Msg : string;         DlgType : TMsgDlgType;
                        Buttons   : TMsgDlgButtons; HelpCtx: Longint;
                        X, Y      : Integer) : Word;
BEGIN
  NStopCounting;
  Result := Borland.Vcl.Dialogs.MessageDlgPos(Msg, DlgType, Buttons, HelpCtx, X, Y);
  NContinueCounting;
END;

function MessageDlgPosHelp( const Msg : string;         DlgType : TMsgDlgType;
                            Buttons   : TMsgDlgButtons; HelpCtx : Longint;
                            X, Y      : Integer;        const HelpFileName : string)
                           : Integer;
BEGIN
  NStopCounting;
  Result := Borland.Vcl.Dialogs.MessageDlgPosHelp(Msg, DlgType, Buttons, HelpCtx,
                                      X, Y, HelpFileName);
  NContinueCounting;
END;

FUNCTION MessageBox ( hWnd : HWND; lpText, lpCaption: String; uType : UINT ) : Integer;
BEGIN
  NStopCounting;
  Result := Borland.Vcl.Windows.MessageBox(hWnd, lpText, lpCaption, uType);
  NContinueCounting;
END;

FUNCTION MessageBoxEx ( hWnd : HWND; lpText, lpCaption: String; uType : UINT; lang : Word ) : Integer;
BEGIN
  NStopCounting;
  Result := Borland.Vcl.Windows.MessageBoxEx(hWnd, lpText, lpCaption, uType, lang);
  NContinueCounting;
END;

function  WaitCommEvent ( hFile              : THandle;
                          out lpEvtMask      : DWORD;
                          const lpOverlapped : TOverlapped) : BOOL; overload;
BEGIN
  NStopCounting;
  Result := Borland.Vcl.Windows.WaitCommEvent(hFile, lpEvtMask, lpOverlapped);
  NContinueCounting;
END;

function  WaitCommEvent ( hFile              : THandle;
                          out lpEvtMask      : DWORD;
                          lpOverlapped       : IntPtr) : BOOL; overload;
BEGIN
  NStopCounting;
  Result := Borland.Vcl.Windows.WaitCommEvent(hFile, lpEvtMask, lpOverlapped);
  NContinueCounting;
END;

function  WaitNamedPipe (lpNamedPipeName : string; nTimeOut : DWORD) : BOOL;
BEGIN
  NStopCounting;
  Result := Borland.Vcl.Windows.WaitNamedPipe(lpNamedPipeName, nTimeOut);
  NContinueCounting;
END;
{$ENDIF }


function  DialogBox ( hInstance    : HINST;
                      lpTemplate   : string;
                      hWndParent   : HWND;
                      lpDialogFunc : TFNDlgProc ) : Integer;
BEGIN
  NStopCounting;
  Result := Borland.Vcl.Windows.DialogBox(hInstance, lpTemplate, hWndParent, lpDialogFunc);
  NContinueCounting;
END;

FUNCTION  DialogBoxIndirect( hInstance  : HINST; const lpDialogTemplate : TDlgTemplate;
                             hWndParent : HWND;        lpDialogFunc     : TFNDlgProc): Integer;
BEGIN
  NStopCounting;
  Result := Borland.Vcl.Windows.DialogBoxIndirect(hInstance, lpDialogTemplate, hWndParent, lpDialogFunc);
  NContinueCounting;
END;


FUNCTION DispatchMessage( CONST lpMsg: TMsg ) : Longint;
BEGIN
  NStopCounting;
  Result := Borland.Vcl.Windows.DispatchMessage(lpMsg);
  NContinueCounting;
END;

PROCEDURE HandleMessage;
BEGIN
  NProfint.NProfStop; Try; NProfint.NProfEnter(1);
  Application.HandleMessage;
  finally; NProfint.NProfExit(1); end;
END;

PROCEDURE ProcessMessages;
BEGIN
  NProfint.NProfStop; Try; NProfint.NProfEnter(1);
  Application.ProcessMessages;
  finally; NProfint.NProfExit(1); end;
END;

PROCEDURE Sleep( zeit : DWORD );
BEGIN
  NStopCounting;
  Borland.Vcl.Windows.Sleep(zeit);
  NContinueCounting;
END;

FUNCTION SleepEx( zeit : DWORD; alertable : BOOL ) : DWORD;
BEGIN
  NStopCounting;
  Result := Borland.Vcl.Windows.SleepEx(zeit, alertable);
  NContinueCounting;
END;

FUNCTION SignalObjectAndWait ( h1, h2 : THandle;
                               ms     : DWord;
                               al     : BOOL) : BOOL;
BEGIN
  NStopCounting;
  Result := Borland.Vcl.Windows.SignalObjectAndWait(h1, h2, ms, al);
  NContinueCounting;
END;

FUNCTION WaitForSingleObject ( h1     : THandle;
                               MS     : DWORD ) : DWORD;
BEGIN
  NStopCounting;
  Result := Borland.Vcl.Windows.WaitForSingleObject ( h1, MS );
  NContinueCounting;
END;

FUNCTION WaitForSingleObjectEx ( h1   : THandle;
                                 MS   : DWORD;
                                 al   : BOOL ) : DWORD;
BEGIN
  NStopCounting;
  Result := Borland.Vcl.Windows.WaitForSingleObjectEx (h1, MS, al);
  NContinueCounting;
END;

{$IFDEF CLR }
FUNCTION WaitForMultipleObjects ( ct             : DWORD;
                                  [in] lpHandles : array of THandle;
                                  wait           : BOOL;
                                  ms             : DWORD ) : DWORD;
BEGIN
  NStopCounting;
  Result := Borland.Vcl.Windows.WaitForMultipleObjects(ct, lpHandles, wait, ms);
  NContinueCounting;
END;

FUNCTION WaitForMultipleObjectsEx ( ct             : DWORD;
                                    [in] lpHandles : array of THandle;
                                    wait           : BOOL;
                                    ms             : DWORD;
                                    al             : BOOL ) : DWORD;
BEGIN
  NStopCounting;
  Result := Borland.Vcl.Windows.WaitForMultipleObjectsEx(ct, lpHandles, wait, ms, al);
  NContinueCounting;
END;

function MsgWaitForMultipleObjects(ct            : DWORD;
                                   [in] pHandles : array of THandle;
                                   Wait          : BOOL;
                                   ms, wm        : DWORD) : DWORD;
BEGIN
  NStopCounting;
  Result := Borland.Vcl.Windows.MsgWaitForMultipleObjects(ct, pHandles, wait, ms, wm);
  NContinueCounting;
END;

FUNCTION MsgWaitForMultipleObjectsEx ( ct             : DWORD;
                                       [in] pHandles : array of THandle;
                                       ms, wm, fl     : DWORD) : DWORD;
BEGIN
  NStopCounting;
  Result := Borland.Vcl.Windows.MsgWaitForMultipleObjectsEx(ct, pHandles, ms, wm, fl);
  NContinueCounting;
END;
{$ENDIF }

FUNCTION WaitForInputIdle ( hp : THandle; ms : DWORD ) : DWORD;
BEGIN
  NStopCounting;
  Result := Borland.Vcl.Windows.WaitForInputIdle(hp, ms);
  NContinueCounting;
END;

FUNCTION WaitMessage : BOOL;
BEGIN
  NStopCounting;
  Result := Borland.Vcl.Windows.WaitMessage;
  NContinueCounting;
END;


PROCEDURE NProfSetComment ( comm : String );
VAR
  i : Integer;
BEGIN
  FOR i := 1 TO Length(comm) DO
    NIntProfSetComment(i-1, comm[i]);
  NIntProfSetComment(Length(comm), Char(0));
END;

{$O-}

INITIALIZATION
  IF NProfIsInitialised = 1 THEN BEGIN
    IF NProfGlobalInit1 = TRUE THEN BEGIN
      NCalcQPCTime802;
    END;
    NProfGlobalInit2(0);
  END;
FINALIZATION
  IF NProfMustBeUnInitialised = 1 THEN BEGIN
    NProfSetFinalComment;
    NProfAppendResults(TRUE);
    NProfUnInitTimer;
  END;
end.

